'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _CanvasTool2 = require('./CanvasTool');

var _CanvasTool3 = _interopRequireDefault(_CanvasTool2);

var _utils = require('./utils');

var Rectangle = (function (_CanvasTool) {
    _inherits(Rectangle, _CanvasTool);

    function Rectangle() {
        _classCallCheck(this, Rectangle);

        _get(Object.getPrototypeOf(Rectangle.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(Rectangle, [{
        key: 'doMouseUp',
        value: function doMouseUp(event) {
            this._isMouseDown = false;
            this._background = null;
        }
    }, {
        key: 'doMouseDown',
        value: function doMouseDown(event) {
            var _mousePosition = (0, _utils.mousePosition)(event);

            var _mousePosition2 = _slicedToArray(_mousePosition, 2);

            var _x = _mousePosition2[0];
            var _y = _mousePosition2[1];

            // store initial position of mouse
            var _ref = [_x, _y];
            this._startX = _ref[0];
            this._startY = _ref[1];

            // Start Drawing
            var _ref2 = [_x, _y];
            this._x = _ref2[0];
            this._y = _ref2[1];
            this._background = this._canvas.toDataURL();
            this._isMouseDown = true;
        }
    }, {
        key: 'doMouseMove',
        value: function doMouseMove(event) {
            var _startX = this._startX;
            var _startY = this._startY;

            var _mousePosition3 = (0, _utils.mousePosition)(event);

            var _mousePosition32 = _slicedToArray(_mousePosition3, 2);

            var _currX = _mousePosition32[0];
            var _currY = _mousePosition32[1];

            if (this._isMouseDown) {
                this._ctx.beginPath();
                this._ctx.clearRect(0, 0, this._canvas.width, this._canvas.height);
                if (this._background) {
                    var image = new Image();
                    image.src = this._background;
                    this._ctx.drawImage(image, 0, 0);
                }
                this._ctx.strokeRect(_startX, _startY, _currX - _startX, _currY - _startY);
                this._ctx.fillRect(_startX, _startY, _currX - _startX, _currY - _startY);
                this._ctx.closePath();
            }
            var _ref3 = [_currX, _currY];
            this._x = _ref3[0];
            this._y = _ref3[1];
        }
    }]);

    return Rectangle;
})(_CanvasTool3['default']);

exports['default'] = Rectangle;
module.exports = exports['default'];