'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Line = require('./Line');

var _Line2 = _interopRequireDefault(_Line);

var _Tools = require('./Tools');

var _Tools2 = _interopRequireDefault(_Tools);

var _Pencil = require('./Pencil');

var _Pencil2 = _interopRequireDefault(_Pencil);

var _History = require('./History');

var _History2 = _interopRequireDefault(_History);

var _Rectangle = require('./Rectangle');

var _Rectangle2 = _interopRequireDefault(_Rectangle);

/**
 * Sketch Tool for React Applications
 */

var SketchField = (function (_React$Component) {
    _inherits(SketchField, _React$Component);

    _createClass(SketchField, null, [{
        key: 'propTypes',
        value: {
            // the color of the line
            color: _react2['default'].PropTypes.string,
            // the fill color of the shape when applicable
            fill: _react2['default'].PropTypes.string,
            // The width of the line
            lineWidth: _react2['default'].PropTypes.number,
            // number of undo/redo steps to maintain
            undoSteps: _react2['default'].PropTypes.number,
            // The tool to use, can be pencil, rectangle, circle, brush;
            tool: _react2['default'].PropTypes.string,
            // image format when calling toDataURL
            imageFormat: _react2['default'].PropTypes.string
        },
        enumerable: true
    }, {
        key: 'defaultProps',
        value: {
            color: 'black',
            fill: 'transparent',
            lineWidth: 2,
            undoSteps: 15,
            tool: _Tools2['default'].Pencil,
            imageFormat: 'image/png'
        },
        enumerable: true
    }]);

    function SketchField(props, context) {
        var _this = this;

        _classCallCheck(this, SketchField);

        _get(Object.getPrototypeOf(SketchField.prototype), 'constructor', this).call(this, props, context);

        this.componentWillUnmount = function () {
            return window.removeEventListener('resize', _this._resize);
        };

        this.componentWillUpdate = function (props, state) {
            return _this._configure(props);
        };

        this._mouseUp = this._mouseUp.bind(this);
        this._mouseDown = this._mouseDown.bind(this);
        this._mouseMove = this._mouseMove.bind(this);
        this._mouseOut = this._mouseOut.bind(this);
        this._resize = this._resize.bind(this);
        this.state = {
            parentWidth: 1,
            content: null
        };
    }

    _createClass(SketchField, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            // Assign the events to canvas element
            this._canvas.addEventListener('mouseup', this._mouseUp, false);
            this._canvas.addEventListener('mousedown', this._mouseDown, false);
            this._canvas.addEventListener('mousemove', this._mouseMove, false);
            this._canvas.addEventListener('mouseout', this._mouseOut, false);
            // Handle the resize of Canvas
            this._canvas.width = _reactDom2['default'].findDOMNode(this).offsetWidth;
            window.addEventListener('resize', this._resize, false);
            // Create context
            this._ctx = this._canvas.getContext('2d');
            // config
            this._configure(this.props);
            // Initialize History
            this._history = new _History2['default'](this.props.undoSteps);
            // Initialize the tools
            this._tools = {};
            this._tools[_Tools2['default'].Line] = new _Line2['default'](this._canvas, this._ctx);
            this._tools[_Tools2['default'].Pencil] = new _Pencil2['default'](this._canvas, this._ctx);
            this._tools[_Tools2['default'].Rectangle] = new _Rectangle2['default'](this._canvas, this._ctx);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            if (props.value && props.value !== this.state.content) {
                this.setContent(props.value);
            }
        }
    }, {
        key: '_configure',

        /**
         * Configure the canvas drawing (color,fill, line width etc.)
         *
         * @param config the configuration to use
         * @private
         */
        value: function _configure(config) {
            if (!config) return;

            var ctx = this._ctx;
            if ('color' in config) {
                ctx.strokeStyle = config.color;
            }
            if ('lineWidth' in config) {
                ctx.lineWidth = config.lineWidth;
            }
            if ('fill' in config) {
                ctx.fillStyle = config.fill;
            }
        }

        /**
         * Track the resize of the window and update our state
         *
         * @param event the resize event
         * @private
         */
    }, {
        key: '_resize',
        value: function _resize(event) {
            var self = this;
            var data = self._canvas.toDataURL();
            this.setState({
                parentWidth: _reactDom2['default'].findDOMNode(this).offsetWidth
            }, function () {
                var img = new Image();
                img.onload = function () {
                    self._ctx.drawImage(img, 0, 0, img.width, img.height, 0, 0, self._canvas.width, self._canvas.height);
                };
                img.src = data;
            });
        }

        /**
         * Mouse up event of canvas assigned as listener
         *
         * @param event the event
         * @private
         */
    }, {
        key: '_mouseUp',
        value: function _mouseUp(event) {
            // Call corresponding tool action
            var tool = this._tools[this.props.tool || _Tools2['default'].Pencil];
            tool.doMouseUp(event);
            // store latest canvas context to history
            var drawing = this._canvas.toDataURL(this.props.imageFormat);
            this._history.keep(drawing);
            // Keep content
            this.setState({ content: drawing });
            // there is no direct on change event
            if (this.props.onChange) {
                this.props.onChange(event, drawing);
            }
        }

        /**
         * The mouse move event of the canvas assigned as listener
         *
         * @param event the mouse move event
         * @private
         */
    }, {
        key: '_mouseMove',
        value: function _mouseMove(event) {
            var tool = this._tools[this.props.tool || _Tools2['default'].Pencil];
            tool.doMouseMove(event);
        }

        /**
         * The mouse down event assigned to canvas
         *
         * @param event the corresponding event
         * @private
         */
    }, {
        key: '_mouseDown',
        value: function _mouseDown(event) {
            var tool = this._tools[this.props.tool || _Tools2['default'].Pencil];
            tool.doMouseDown(event);
        }

        /**
         * The mouse out event assigned to canvas
         *
         * @param event the corresponding event
         * @private
         */
    }, {
        key: '_mouseOut',
        value: function _mouseOut(event) {
            var tool = this._tools[this.props.tool || _Tools2['default'].Pencil];
            tool.doMouseOut(event);
            // there is no direct on change event
            var content = this._canvas.toDataURL(this.props.imageFormat);
            this.setState({
                content: content
            });
            if (this.props.onChange) {
                this.props.onChange(event, content);
            }
        }

        /**
         * Perform an undo operation on canvas, if it cannot undo it will leave the canvas intact
         */
    }, {
        key: 'undo',
        value: function undo() {
            var history = this._history;
            // we do not want the latest canvas but the one before  that
            if (history.canUndo()) {
                var ctx = this._ctx;
                var canvas = this._canvas;
                if (ctx) {
                    ctx.beginPath();
                    ctx.clearRect(0, 0, canvas.width, canvas.height);
                    var image = new Image();
                    var undoCanvas = history.undo();
                    image.src = undoCanvas;
                    ctx.drawImage(image, 0, 0);
                    ctx.stroke();
                    ctx.closePath();
                    this.setState({
                        content: undoCanvas
                    });
                    if (this.props.onChange) {
                        this.props.onChange(event, undoCanvas);
                    }
                }
            }
        }

        /**
         * Perform a redo operation on canvas, if it cannot redo it will leave the canvas intact
         */
    }, {
        key: 'redo',
        value: function redo() {
            var history = this._history;
            if (history.canRedo()) {
                var ctx = this._ctx;
                var canvas = this._canvas;
                if (ctx) {
                    ctx.beginPath();
                    ctx.clearRect(0, 0, canvas.width, canvas.height);
                    var image = new Image();
                    var redoCanvas = history.redo();
                    image.src = redoCanvas;
                    ctx.drawImage(image, 0, 0);
                    ctx.stroke();
                    ctx.closePath();
                    this.setState({
                        content: redoCanvas
                    });
                    // there is no direct on change event
                    if (this.props.onChange) {
                        this.props.onChange(event, redoCanvas);
                    }
                }
            }
        }

        /**
         * Delegation method to check if we can perform an undo Operation, useful to disable/enable possible buttons
         *
         * @returns {*} true if we can undo otherwise false
         */
    }, {
        key: 'canUndo',
        value: function canUndo() {
            return this._history.canUndo();
        }

        /**
         * Delegation method to check if we can perform a redo Operation, useful to disable/enable possible buttons
         *
         * @returns {*} true if we can redo otherwise false
         */
    }, {
        key: 'canRedo',
        value: function canRedo() {
            return this._history.canRedo();
        }

        /**
         * Get the current content from Canvas
         *
         * @returns {null} the data of the canvas
         */
    }, {
        key: 'getContent',
        value: function getContent() {
            return this.state.content;
        }

        /**
         * Set the content of Canvas to the given one
         *
         * @param drawing the content to set to the canvas
         */
    }, {
        key: 'setContent',
        value: function setContent(drawing) {
            var image = new Image();
            image.src = drawing;
            this._ctx.drawImage(image, 0, 0);
            this._ctx.stroke();
            this._history.keep(drawing);
            this.setState({ content: drawing });
        }

        /**
         * Clear the content of the canvas, this will also keep the last version of it to history
         */
    }, {
        key: 'clear',
        value: function clear() {
            var ctx = this._ctx;
            var canvas = this._canvas;
            var history = this._history;
            if (ctx) {
                // keep last canvas first
                history.keep(this._canvas.toDataURL(this.props.imageFormat));
                // clear canvas
                ctx.beginPath();
                ctx.clearRect(0, 0, canvas.width, canvas.height);
                ctx.stroke();
                ctx.closePath();
            }
            this.setState({ content: null });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props;
            var className = _props.className;
            var disabled = _props.disabled;
            var style = _props.style;
            var onChange = _props.onChange;
            var width = _props.width;
            var height = _props.height;

            var other = _objectWithoutProperties(_props, ['className', 'disabled', 'style', 'onChange', 'width', 'height']);

            return _react2['default'].createElement(
                'div',
                { className: className, style: style },
                _react2['default'].createElement(
                    'canvas',
                    {
                        ref: function (c) {
                            return _this2._canvas = c;
                        },
                        width: width || this.state.parentWidth,
                        height: height || '512px' },
                    ' Sorry, Canvas element is not supported'
                )
            );
        }
    }]);

    return SketchField;
})(_react2['default'].Component);

exports['default'] = SketchField;
module.exports = exports['default'];